#ifndef __TVQDEC_H_
#define __TVQDEC_H_

#include <twinvq.h>

#ifdef __cplusplus
extern "C" {
#endif

  /*
   * Init and cleanup
  */
  int	TvqInitialize(headerInfo* setupInfo, INDEX*, int);
  void	TvqTerminate(INDEX*);
  void	TvqGetVectorInfo(int* bits0[], int* bits1[]);
  void	TvqResetFrameCounter();

  /*
   * TwinVQ decoder function
   */
  void	TvqDecodeFrame(INDEX* indexp, float out[]);
  int	TvqWtypeToBtype(int w_type, int* btype);
  void	TvqUpdateVectorInfo(int varbits, int* ndiv, int bits0[], int bits1[]);
  void	TvqSetFrameCounter(int position);

  /*
   * TwinVQ query functions
   */
  int	TvqCheckVersion(char* versionID);
  void	TvqGetSetupInfo(headerInfo* setupInfo);
  void	TvqGetConfInfo(tvqConfInfo* cf);
  int	TvqGetFrameSize();
  int	TvqGetNumChannels();
  int	TvqGetBitRate();
  float	TvqGetSamplingRate();
  int	TvqGetNumFixedBitsPerFrame();
  int	TvqGetNumFrames();
  int	TvqGetModuleVersion(char* versionString);

  /*
   * TwinVQ FB coding tool control
   * not necessary for use
   */
#ifdef V2PLUS_SUPPORT
  void	TvqFbCountUsedBits(int nbit);
  float	TvqGetFbCurrentBitrate();
  int	TvqGetFbTotalBits();
#endif


#ifdef __cplusplus
}
#endif

#endif /* __TVQDEC_H_ */
